diff --git a/src/common/kmgr_utils.c b/src/common/kmgr_utils.c
new file mode 100644
index ...7bb4c5e
*** a/src/common/kmgr_utils.c
--- b/src/common/kmgr_utils.c
***************
*** 0 ****
--- 1,529 ----
+ /*-------------------------------------------------------------------------
+  *
+  * kmgr_utils.c
+  *	  Shared frontend/backend for cryptographic key management
+  *
+  * Copyright (c) 2020, PostgreSQL Global Development Group
+  *
+  * IDENTIFICATION
+  *	  src/common/kmgr_utils.c
+  *
+  *-------------------------------------------------------------------------
+  */
+ 
+ #ifndef FRONTEND
+ #include "postgres.h"
+ #else
+ #include "postgres_fe.h"
+ #endif
+ 
+ #include <unistd.h>
+ #include <sys/stat.h>
+ 
+ #ifdef FRONTEND
+ #include "common/logging.h"
+ #endif
+ #include "common/file_perm.h"
+ #include "common/kmgr_utils.h"
+ #include "common/sha2.h"
+ #include "crypto/kmgr.h"
+ #include "postmaster/postmaster.h"
+ #include "utils/elog.h"
+ #include "storage/fd.h"
+ 
+ #ifndef FRONTEND
+ #include "pgstat.h"
+ #include "storage/fd.h"
+ #endif
+ 
+ #define KMGR_PROMPT_MSG "Enter database encryption pass phrase: "
+ 
+ #ifdef FRONTEND
+ static FILE *open_pipe_stream(const char *command);
+ static int	close_pipe_stream(FILE *file);
+ #endif
+ 
+ static void read_one_keyfile(const char *dataDir, uint32 id, CryptoKey *key_p);
+ 
+ /* Return a key wrap context initialized with the given keys */
+ PgKeyWrapCtx *
+ pg_create_keywrap_ctx(uint8 key[KMGR_ENC_KEY_LEN], uint8 mackey[KMGR_MAC_KEY_LEN])
+ {
+ 	PgKeyWrapCtx *ctx;
+ 
+ 	ctx = (PgKeyWrapCtx *) palloc0(sizeof(PgKeyWrapCtx));
+ 
+ 	/* Create and initialize a cipher context */
+ 	ctx->cipherctx = pg_cipher_ctx_create(PG_CIPHER_AES_CBC, key, KMGR_ENC_KEY_LEN);
+ 	if (ctx->cipherctx == NULL)
+ 		return NULL;
+ 
+ 	/* Set encryption key and MAC key */
+ 	memcpy(ctx->key, key, KMGR_ENC_KEY_LEN);
+ 	memcpy(ctx->mackey, mackey, KMGR_MAC_KEY_LEN);
+ 
+ 	return ctx;
+ }
+ 
+ /* Free the key wrap context */
+ void
+ pg_free_keywrap_ctx(PgKeyWrapCtx *ctx)
+ {
+ 	if (!ctx)
+ 		return;
+ 
+ 	Assert(ctx->cipherctx);
+ 
+ 	pg_cipher_ctx_free(ctx->cipherctx);
+ 
+ #ifndef FRONTEND
+ 	pfree(ctx);
+ #else
+ 	pg_free(ctx);
+ #endif
+ }
+ 
+ /*
+  * Encrypt the given data. Return true and set encrypted data to 'out' if
+  * success.  Otherwise return false. The caller must allocate sufficient space
+  * for cipher data calculated by using KmgrSizeOfCipherText(). Please note that
+  * this function modifies 'out' data even on failure case.
+  */
+ bool
+ kmgr_wrap_key(PgKeyWrapCtx *ctx, CryptoKey *in, CryptoKey *out)
+ {
+ 	uint8	*hmac;
+ 	uint8	*iv;
+ 	uint8	*enc;
+ 	int		enclen;
+ 
+ 	Assert(ctx && in && out);
+ 
+ 	hmac = out->key;
+ 	iv = hmac + KMGR_HMAC_LEN;
+ 	enc = iv + PG_AES_IV_SIZE;
+ 
+ 	/* Generate IV */
+ 	if (!pg_strong_random(iv, PG_AES_IV_SIZE))
+ 		return false;
+ 
+ 	if (!pg_cipher_encrypt(ctx->cipherctx, in->key, in->klen, enc, &enclen, iv))
+ 		return false;
+ 
+ 	if (!pg_HMAC_SHA512(ctx->mackey, enc, enclen, hmac))
+ 		return false;
+ 
+ 	out->klen = KmgrSizeOfCipherText(in->klen);;
+ 	Assert(out->klen == KMGR_HMAC_LEN + PG_AES_IV_SIZE + enclen);
+ 
+ 	return true;
+ }
+ 
+ /*
+  * Decrypt the given Data. Return true and set plain text data to `out` if
+  * success.  Otherwise return false. The caller must allocate sufficient space
+  * for cipher data calculated by using KmgrSizeOfPlainText(). Please note that
+  * this function modifies 'out' data even on failure case.
+  */
+ bool
+ kmgr_unwrap_key(PgKeyWrapCtx *ctx, CryptoKey *in, CryptoKey *out)
+ {
+ 	uint8	hmac[KMGR_HMAC_LEN];
+ 	uint8   *expected_hmac;
+ 	uint8   *iv;
+ 	uint8	*enc;
+ 	int		enclen;
+ 
+ 	Assert(ctx && in && out);
+ 
+ 	expected_hmac = in->key;
+ 	iv = expected_hmac + KMGR_HMAC_LEN;
+ 	enc = iv + PG_AES_IV_SIZE;
+ 	enclen = in->klen - (enc - in->key);
+ 
+ 	/* Verify the correctness of HMAC */
+ 	if (!pg_HMAC_SHA512(ctx->mackey, enc, enclen, hmac))
+ 		return false;
+ 
+ 	if (memcmp(hmac, expected_hmac, KMGR_HMAC_LEN) != 0)
+ 		return false;
+ 
+ 	/* Decrypt encrypted data */
+ 	if (!pg_cipher_decrypt(ctx->cipherctx, enc, enclen, out->key, &(out->klen), iv))
+ 		return false;
+ 
+ 	return true;
+ }
+ 
+ /*
+  * Verify the correctness of the given passphrase by unwrapping the given keys.
+  * If the given passphrase is correct we set unwrapped keys to keys_out and return
+  * true.  Otherwise return false.  Please note that this function changes the
+  * contents of keys_out even on failure.  Both keys_in and keys_out must be the
+  * same length, nkey.
+  */
+ bool
+ kmgr_verify_passphrase(char *passphrase, int passlen,
+ 					   CryptoKey *keys_in, CryptoKey *keys_out, int nkeys)
+ {
+ 	PgKeyWrapCtx *tmpctx;
+ 	uint8		user_enckey[KMGR_ENC_KEY_LEN];
+ 	uint8		user_hmackey[KMGR_MAC_KEY_LEN];
+ 
+ 	/*
+ 	 * Create temporary wrap context with encryption key and HMAC key extracted
+ 	 * from the passphrase.
+ 	 */
+ 	kmgr_derive_keys(passphrase, passlen, user_enckey, user_hmackey);
+ 	tmpctx = pg_create_keywrap_ctx(user_enckey, user_hmackey);
+ 
+ 	for (int i = 0; i < nkeys; i++)
+ 	{
+ 
+ 		if (!kmgr_unwrap_key(tmpctx, &(keys_in[i]), &(keys_out[i])))
+ 		{
+ 			/* The passphrase is not correct */
+ 			pg_free_keywrap_ctx(tmpctx);
+ 			return false;
+ 		}
+ 	}
+ 
+ 	/* The passphrase is correct, free the cipher context */
+ 	pg_free_keywrap_ctx(tmpctx);
+ 
+ 	return true;
+ }
+ 
+ /* Generate encryption key and mac key from given passphrase */
+ void
+ kmgr_derive_keys(char *passphrase, Size passlen,
+ 				 uint8 enckey[KMGR_ENC_KEY_LEN],
+ 				 uint8 mackey[KMGR_MAC_KEY_LEN])
+ {
+ 	pg_sha256_ctx ctx1;
+ 	pg_sha512_ctx ctx2;
+ 
+ 	StaticAssertStmt(KMGR_ENC_KEY_LEN == PG_AES256_KEY_LEN,
+ 		"derived encryption key size does not match AES256 key size");
+ 	StaticAssertStmt(KMGR_MAC_KEY_LEN == PG_HMAC_SHA512_KEY_LEN,
+ 		"derived mac key size does not match HMAC-SHA512 key size");
+ 
+ 	/* Generate encryption key from passphrase */
+ 	pg_sha256_init(&ctx1);
+ 	pg_sha256_update(&ctx1, (const uint8 *) passphrase, passlen);
+ 	pg_sha256_final(&ctx1, enckey);
+ 
+ 	/* Generate mac key from passphrase */
+ 	pg_sha512_init(&ctx2);
+ 	pg_sha512_update(&ctx2, (const uint8 *) passphrase, passlen);
+ 	pg_sha512_final(&ctx2, mackey);
+ }
+ 
+ /*
+  * Run cluster passphrase command.
+  *
+  * prompt will be substituted for %p, file descriptor for %R
+  *
+  * The result will be put in buffer buf, which is of size size.
+  * The return value is the length of the actual result.
+  */
+ int
+ kmgr_run_cluster_passphrase_command(char *passphrase_command, char *buf,
+ 									int size)
+ {
+ 	char		command[MAXPGPATH];
+ 	char	   *p;
+ 	char	   *dp;
+ 	char	   *endp;
+ 	FILE	   *fh;
+ 	int			pclose_rc;
+ 	size_t		len = 0;
+ 
+ 	Assert(size > 0);
+ 	buf[0] = '\0';
+ 
+ 	dp = command;
+ 	endp = command + MAXPGPATH - 1;
+ 	*endp = '\0';
+ 
+ 	for (p = passphrase_command; *p; p++)
+ 	{
+ 		if (p[0] == '%')
+ 		{
+ 			switch (p[1])
+ 			{
+ 				case 'p':
+ 					strlcpy(dp, KMGR_PROMPT_MSG, strlen(KMGR_PROMPT_MSG)+1);
+ 					dp += strlen(KMGR_PROMPT_MSG);
+ 					p++;
+ 					break;
+ 				case 'R':
+ 					/* Safe from overflow? */
+ 					dp += sprintf(dp, "%d", terminal_fd);
+ 					p++;
+ 					break;
+ 				case '%':
+ 					p++;
+ 					if (dp < endp)
+ 						*dp++ = *p;
+ 					break;
+ 				default:
+ 					if (dp < endp)
+ 						*dp++ = *p;
+ 					break;
+ 			}
+ 		}
+ 		else
+ 		{
+ 			if (dp < endp)
+ 				*dp++ = *p;
+ 		}
+ 	}
+ 	*dp = '\0';
+ 
+ #ifdef FRONTEND
+ 	fh = open_pipe_stream(command);
+ 	if (fh == NULL)
+ 	{
+ 		pg_log_fatal("could not execute command \"%s\": %m",
+ 					 command);
+ 		exit(EXIT_FAILURE);
+ 	}
+ #else
+ 	fh = OpenPipeStream(command, "r");
+ 	if (fh == NULL)
+ 		ereport(ERROR,
+ 				(errcode_for_file_access(),
+ 				 errmsg("could not execute command \"%s\": %m",
+ 						command)));
+ #endif
+ 
+ 	if ((len = fread(buf, sizeof(char), size, fh)) < size)
+ 	{
+ 		if (ferror(fh))
+ 		{
+ #ifdef FRONTEND
+ 			pg_log_fatal("could not read from command \"%s\": %m",
+ 						 command);
+ 			exit(EXIT_FAILURE);
+ #else
+ 			ereport(ERROR,
+ 					(errcode_for_file_access(),
+ 					 errmsg("could not read from command \"%s\": %m",
+ 							command)));
+ #endif
+ 		}
+ 	}
+ 
+ #ifdef FRONTEND
+ 	pclose_rc = close_pipe_stream(fh);
+ #else
+ 	pclose_rc = ClosePipeStream(fh);
+ #endif
+ 
+ 	if (pclose_rc == -1)
+ 	{
+ #ifdef FRONTEND
+ 		pg_log_fatal("could not close pipe to external command: %m");
+ 		exit(EXIT_FAILURE);
+ #else
+ 		ereport(ERROR,
+ 				(errcode_for_file_access(),
+ 				 errmsg("could not close pipe to external command: %m")));
+ #endif
+ 	}
+ 	else if (pclose_rc != 0)
+ 	{
+ #ifdef FRONTEND
+ 		pg_log_fatal("command \"%s\" failed", command);
+ 		exit(EXIT_FAILURE);
+ #else
+ 		ereport(ERROR,
+ 				(errcode_for_file_access(),
+ 				 errmsg("command \"%s\" failed",
+ 						command),
+ 				 errdetail_internal("%s", wait_result_to_str(pclose_rc))));
+ #endif
+ 	}
+ 
+ 	return len;
+ }
+ 
+ #ifdef FRONTEND
+ static FILE *
+ open_pipe_stream(const char *command)
+ {
+ 	FILE	   *res;
+ 
+ #ifdef WIN32
+ 	size_t		cmdlen = strlen(command);
+ 	char	   *buf;
+ 	int			save_errno;
+ 
+ 	buf = malloc(cmdlen + 2 + 1);
+ 	if (buf == NULL)
+ 	{
+ 		errno = ENOMEM;
+ 		return NULL;
+ 	}
+ 	buf[0] = '"';
+ 	mempcy(&buf[1], command, cmdlen);
+ 	buf[cmdlen + 1] = '"';
+ 	buf[cmdlen + 2] = '\0';
+ 
+ 	res = _popen(buf, "r");
+ 
+ 	save_errno = errno;
+ 	free(buf);
+ 	errno = save_errno;
+ #else
+ 	res = popen(command, "r");
+ #endif							/* WIN32 */
+ 	return res;
+ }
+ 
+ static int
+ close_pipe_stream(FILE *file)
+ {
+ #ifdef WIN32
+ 	return _pclose(file);
+ #else
+ 	return pclose(file);
+ #endif							/* WIN32 */
+ }
+ #endif							/* FRONTEND */
+ 
+ CryptoKey *
+ kmgr_get_cryptokeys(const char *path, int *nkeys)
+ {
+ 	struct dirent *de;
+ 	DIR			*dir;
+ 	CryptoKey	*keys;
+ 
+ #ifndef FRONTEND
+ 	if ((dir = AllocateDir(path)) == NULL)
+ 		ereport(ERROR,
+ 				(errcode_for_file_access(),
+ 				 errmsg("could not open directory \"%s\": %m",
+ 						path)));
+ #else
+ 	if ((dir = opendir(path)) == NULL)
+ 		pg_log_fatal("could not open directory \"%s\": %m", path);
+ #endif
+ 
+ 	keys = (CryptoKey *) palloc0(sizeof(CryptoKey) * KMGR_MAX_INTERNAL_KEYS);
+ 	*nkeys = 0;
+ 
+ #ifndef FRONTEND
+ 	while ((de = ReadDir(dir, KMGR_DIR)) != NULL)
+ #else
+ 	while ((de = readdir(dir)) != NULL)
+ #endif
+ 	{
+ 		if (strlen(de->d_name) == 4 &&
+ 			strspn(de->d_name, "0123456789ABCDEF") == 4)
+ 		{
+ 			uint32		id;
+ 
+ 			id = strtoul(de->d_name, NULL, 16);
+ 
+ 			if (id < 0 || id >= KMGR_MAX_INTERNAL_KEYS)
+ 			{
+ #ifndef FRONTEND
+ 				elog(ERROR, "invalid cryptographic key identifier %u", id);
+ #else
+ 				pg_log_fatal("invalid cryptographic key identifier %u", id);
+ #endif
+ 			}
+ 
+ 			if (*nkeys >= KMGR_MAX_INTERNAL_KEYS)
+ 			{
+ #ifndef FRONTEND
+ 				elog(ERROR, "too many cryptographic kes");
+ #else
+ 				pg_log_fatal("too many cryptographic keys");
+ #endif
+ 			}
+ 
+ 			read_one_keyfile(path, id, &(keys[id]));
+ 			(*nkeys)++;
+ 		}
+ 	}
+ 
+ #ifndef FRONTEND
+ 	FreeDir(dir);
+ #else
+ 	closedir(dir);
+ #endif
+ 
+ 	return keys;
+ }
+ 
+ static void
+ read_one_keyfile(const char *cryptoKeyDir, uint32 id, CryptoKey *key_p)
+ {
+ 	char		path[MAXPGPATH];
+ 	int			fd;
+ 	int			r;
+ 
+ 	CryptoKeyFilePath(path, cryptoKeyDir, id);
+ 
+ #ifndef FRONTEND
+ 	if ((fd = OpenTransientFile(path, O_RDONLY | PG_BINARY)) == -1)
+ 		ereport(ERROR,
+ 				(errcode_for_file_access(),
+ 				 errmsg("could not open file \"%s\" for reading: %m",
+ 						path)));
+ #else
+ 	if ((fd = open(path, O_RDONLY | PG_BINARY, 0)) == -1)
+ 		pg_log_fatal("could not open file \"%s\" for reading: %m",
+ 					 path);
+ #endif
+ 
+ #ifndef FRONTEND
+ 	pgstat_report_wait_start(WAIT_EVENT_KEY_FILE_READ);
+ #endif
+ 
+ 	/* Get key bytes */
+ 	r = read(fd, key_p, sizeof(CryptoKey));
+ 	if (r != sizeof(CryptoKey))
+ 	{
+ 		if (r < 0)
+ 		{
+ #ifndef FRONTEND
+ 			ereport(ERROR,
+ 					(errcode_for_file_access(),
+ 					 errmsg("could not read file \"%s\": %m", path)));
+ #else
+ 			pg_log_fatal("could not read file \"%s\": %m", path);
+ #endif
+ 		}
+ 		else
+ 		{
+ #ifndef FRONTEND
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_DATA_CORRUPTED),
+ 					 errmsg("could not read file \"%s\": read %d of %zu",
+ 							path, r, sizeof(CryptoKey))));
+ #else
+ 			pg_log_fatal("could not read file \"%s\": read %d of %zu",
+ 						 path, r, sizeof(CryptoKey));
+ #endif
+ 		}
+ 	}
+ 
+ #ifndef FRONTEND
+ 	pgstat_report_wait_end();
+ #endif
+ 
+ #ifndef FRONTEND
+ 	if (CloseTransientFile(fd) != 0)
+ 		ereport(ERROR,
+ 				(errcode_for_file_access(),
+ 				 errmsg("could not close file \"%s\": %m",
+ 						path)));
+ #else
+ 	if (close(fd) != 0)
+ 		pg_log_fatal("could not close file \"%s\": %m", path);
+ #endif
+ }
diff --git a/src/include/access/xlog.h b/src/include/access/xlog.h
new file mode 100644
index 221af87..33f28c7
*** a/src/include/access/xlog.h
--- b/src/include/access/xlog.h
*************** extern void UpdateControlFile(void);
*** 319,324 ****
--- 319,325 ----
  extern uint64 GetSystemIdentifier(void);
  extern char *GetMockAuthenticationNonce(void);
  extern bool DataChecksumsEnabled(void);
+ extern bool	KeyManagementEnabled(void);
  extern XLogRecPtr GetFakeLSNForUnloggedRel(void);
  extern Size XLOGShmemSize(void);
  extern void XLOGShmemInit(void);
diff --git a/src/include/catalog/pg_control.h b/src/include/catalog/pg_control.h
new file mode 100644
index 06bed90..c7df6d6
*** a/src/include/catalog/pg_control.h
--- b/src/include/catalog/pg_control.h
*************** typedef struct ControlFileData
*** 226,231 ****
--- 226,234 ----
  	 */
  	char		mock_authentication_nonce[MOCK_AUTH_NONCE_LEN];
  
+ 	/* Key management cipher. Zero if no version */
+ 	uint32		key_management_version;
+ 
  	/* CRC of all above ... MUST BE LAST! */
  	pg_crc32c	crc;
  } ControlFileData;
diff --git a/src/include/common/cipher.h b/src/include/common/cipher.h
new file mode 100644
index ...f782791
*** a/src/include/common/cipher.h
--- b/src/include/common/cipher.h
***************
*** 0 ****
--- 1,78 ----
+ /*-------------------------------------------------------------------------
+  *
+  * cipher.h
+  *		Declarations for cryptographic functions
+  *
+  * Portions Copyright (c) 2020, PostgreSQL Global Development Group
+  *
+  * src/include/common/cipher.h
+  *
+  *-------------------------------------------------------------------------
+  */
+ #ifndef CIPHER_H
+ #define CIPHER_H
+ 
+ #ifdef USE_OPENSSL
+ #include <openssl/evp.h>
+ #include <openssl/conf.h>
+ #include <openssl/err.h>
+ #endif
+ 
+ /*
+  * Supported symmetric encryption algorithm. These identifiers are passed
+  * to pg_cipher_ctx_create() function, and then actual encryption
+  * implementations need to initialize their context of the given encryption
+  * algorithm.
+  */
+ #define PG_CIPHER_AES_CBC			0
+ #define PG_MAX_CIPHER_ID			1
+ 
+ /* AES128/192/256 various length definitions */
+ #define PG_AES128_KEY_LEN			(128 / 8)
+ #define PG_AES192_KEY_LEN			(192 / 8)
+ #define PG_AES256_KEY_LEN			(256 / 8)
+ 
+ /*
+  * The encrypted data is a series of blocks of size. Initialization
+  * vector(IV) is the same size of cipher block.
+  */
+ #define PG_AES_BLOCK_SIZE			16
+ #define PG_AES_IV_SIZE				(PG_AES_BLOCK_SIZE)
+ 
+ /* HMAC key and HMAC length. We use HMAC-SHA256 */
+ #define PG_HMAC_SHA512_KEY_LEN		64
+ #define PG_HMAC_SHA512_LEN			64
+ 
+ #ifdef USE_OPENSSL
+ typedef EVP_CIPHER_CTX cipher_private_ctx;
+ #else
+ typedef void cipher_private_ctx;
+ #endif
+ 
+ /*
+  * This struct has two implementation-private context for
+  * encryption and decryption. The caller must create the encryption
+  * context using by pg_cipher_ctx_create() and pass the context  to
+  * pg_cipher_encrypt() or pg_cipher_decrypt().
+  */
+ typedef struct PgCipherCtx
+ {
+ 	cipher_private_ctx *encctx;
+ 	cipher_private_ctx *decctx;
+ } PgCipherCtx;
+ 
+ extern PgCipherCtx *pg_cipher_ctx_create(int cipher, uint8 *key, int klen);
+ extern void pg_cipher_ctx_free(PgCipherCtx *ctx);
+ extern bool pg_cipher_encrypt(PgCipherCtx *ctx,
+ 							  const uint8 *in, int inlen,
+ 							  uint8 *out, int *outlen,
+ 							  const uint8 *iv);
+ extern bool pg_cipher_decrypt(PgCipherCtx *ctx,
+ 							  const uint8 *in, int inlen,
+ 							  uint8 *out, int *outlen,
+ 							  const uint8 *iv);
+ extern bool pg_HMAC_SHA512(const uint8 *key,
+ 						   const uint8 *in, int inlen,
+ 						   uint8 *out);
+ 
+ #endif							/* CIPHER_H */
diff --git a/src/include/common/cipher_openssl.h b/src/include/common/cipher_openssl.h
new file mode 100644
index ...0fd1308
*** a/src/include/common/cipher_openssl.h
--- b/src/include/common/cipher_openssl.h
***************
*** 0 ****
--- 1,37 ----
+ /*-------------------------------------------------------------------------
+  *
+  * cipher_openssl.h
+  *		Declarations for helper functions using OpenSSL
+  *
+  * Portions Copyright (c) 2020, PostgreSQL Global Development Group
+  *
+  * src/include/common/cipher_openssl.h
+  *
+  *-------------------------------------------------------------------------
+  */
+ #ifndef CIPHER_OPENSSL_H
+ #define CIPHER_OPENSSL_H
+ 
+ #ifndef FRONTEND
+ #include "postgres.h"
+ #else
+ #include "postgres_fe.h"
+ #endif
+ 
+ #include "common/cipher.h"
+ 
+ extern EVP_CIPHER_CTX *ossl_cipher_ctx_create(int cipher, uint8 *key, int klen,
+ 											  bool enc);
+ extern void ossl_cipher_ctx_free(EVP_CIPHER_CTX *ctx);
+ extern bool ossl_cipher_encrypt(EVP_CIPHER_CTX *ctx,
+ 								const uint8 *in, int inlen,
+ 								uint8 *out, int *outlen,
+ 								const uint8 *iv);
+ extern bool ossl_cipher_decrypt(EVP_CIPHER_CTX *ctx,
+ 								const uint8 *in, int inlen,
+ 								uint8 *out,	int *outlen,
+ 								const uint8 *iv);
+ extern bool ossl_HMAC_SHA512(const uint8 *key,
+ 							 const uint8 *in, int inlen,
+ 							 uint8 *out);
+ #endif
diff --git a/src/include/common/kmgr_utils.h b/src/include/common/kmgr_utils.h
new file mode 100644
index ...1dc8f43
*** a/src/include/common/kmgr_utils.h
--- b/src/include/common/kmgr_utils.h
***************
*** 0 ****
--- 1,105 ----
+ /*-------------------------------------------------------------------------
+  *
+  * kmgr_utils.h
+  *		Declarations for utility function for key management
+  *
+  * Portions Copyright (c) 2020, PostgreSQL Global Development Group
+  *
+  * src/include/common/kmgr_utils.h
+  *
+  *-------------------------------------------------------------------------
+  */
+ #ifndef KMGR_UTILS_H
+ #define KMGR_UTILS_H
+ 
+ #include "common/cipher.h"
+ 
+ /* Current version number */
+ #define KMGR_VERSION 1
+ 
+ /*
+  * Directory where cryptographic keys reside within PGDATA. KMGR_DIR_TMP
+  * is used during cluster passphrase rotation.
+  */
+ #define KMGR_DIR			"pg_cryptokeys"
+ #define KMGR_TMP_DIR		"pg_cryptokeys_tmp"
+ 
+ /*
+  * Identifiers of internal keys.  When adding a new internal key, we
+  * also need to add its key length to internalKeyLengths.
+  */
+ /* #define KMGR_XXX_KEY_ID 0 */
+ #define KMGR_MAX_INTERNAL_KEYS	0
+ 
+ /* Encryption key and MAC key used for key wrapping */
+ #define KMGR_ENC_KEY_LEN			PG_AES256_KEY_LEN
+ #define KMGR_MAC_KEY_LEN			PG_HMAC_SHA512_KEY_LEN
+ #define KMGR_HMAC_LEN				PG_HMAC_SHA512_LEN
+ 
+ /* Key wrapping key consists of encryption key and mac key */
+ #define KMGR_KEY_LEN				(PG_AEAD_ENC_KEY_LEN + PG_AEAD_MAC_KEY_LEN)
+ 
+ /* Allowed length of cluster passphrase */
+ #define KMGR_MIN_PASSPHRASE_LEN 	64
+ #define KMGR_MAX_PASSPHRASE_LEN		1024
+ 
+ /* Maximum length of key the key manager can store */
+ #define KMGR_MAX_KEY_LEN			128
+ #define KMGR_MAX_WRAPPED_KEY_LEN	KmgrSizeOfCipherText(KMGR_MAX_KEY_LEN)
+ 
+ /*
+  * Size of encrypted key size with padding. We use PKCS#7 padding,
+  * described in RFC 5652.
+  */
+ #define SizeOfDataWithPadding(klen) \
+ 	((int)(klen) + (PG_AES_BLOCK_SIZE - ((int)(klen) % PG_AES_BLOCK_SIZE)))
+ 
+ /* Macros to compute the size of cipher text and plain text */
+ #define KmgrSizeOfCipherText(len) \
+ 	(KMGR_MAC_KEY_LEN + PG_AES_IV_SIZE + SizeOfDataWithPadding((int)(len)))
+ #define KmgrSizeOfPlainText(klen) \
+ 	((int)(klen) - (KMGR_MAC_KEY_LEN + PG_AES_IV_SIZE))
+ 
+ /* CryptoKey file name is keys id */
+ #define CryptoKeyFilePath(path, dir, id) \
+ 	snprintf((path), MAXPGPATH, "%s/%04X", (dir), (id))
+ 
+ /*
+  * Cryptographic key data structure. This structure is used for
+  * both on-disk (raw key) and on-memory (wrapped key).
+  */
+ typedef struct CryptoKey
+ {
+ 	int		klen;
+ 	uint8	key[KMGR_MAX_WRAPPED_KEY_LEN];
+ } CryptoKey;
+ 
+ /* Key wrapping cipher context */
+ typedef struct PgKeyWrapCtx
+ {
+ 	uint8			key[KMGR_ENC_KEY_LEN];
+ 	uint8			mackey[KMGR_MAC_KEY_LEN];
+ 	PgCipherCtx		*cipherctx;
+ } PgKeyWrapCtx;
+ 
+ extern PgKeyWrapCtx *pg_create_keywrap_ctx(uint8 key[KMGR_ENC_KEY_LEN],
+ 										   uint8 mackey[KMGR_MAC_KEY_LEN]);
+ extern void pg_free_keywrap_ctx(PgKeyWrapCtx *ctx);
+ extern bool kmgr_wrap_key(PgKeyWrapCtx *ctx, CryptoKey *in, CryptoKey *out);
+ extern bool kmgr_unwrap_key(PgKeyWrapCtx *ctx, CryptoKey *in, CryptoKey *out);
+ 
+ 
+ 
+ extern void kmgr_derive_keys(char *passphrase, Size passlen,
+ 							 uint8 enckey[KMGR_ENC_KEY_LEN],
+ 							 uint8 mackey[KMGR_MAC_KEY_LEN]);
+ extern bool kmgr_verify_passphrase(char *passphrase, int passlen,
+ 								   CryptoKey *keys_in, CryptoKey *keys_out,
+ 								   int nkey);
+ extern bool kmgr_wrap_key(PgKeyWrapCtx *ctx, CryptoKey *in, CryptoKey *out);
+ extern bool kmgr_unwrap_key(PgKeyWrapCtx *ctx, CryptoKey *in, CryptoKey *out);
+ extern int	kmgr_run_cluster_passphrase_command(char *passphrase_command,
+ 												char *buf, int size);
+ extern CryptoKey *kmgr_get_cryptokeys(const char *path, int *nkeys);
+ 
+ #endif							/* KMGR_UTILS_H */
diff --git a/src/include/crypto/kmgr.h b/src/include/crypto/kmgr.h
new file mode 100644
index ...783f06d
*** a/src/include/crypto/kmgr.h
--- b/src/include/crypto/kmgr.h
***************
*** 0 ****
--- 1,29 ----
+ /*-------------------------------------------------------------------------
+  *
+  * kmgr.h
+  *
+  * Portions Copyright (c) 2020, PostgreSQL Global Development Group
+  *
+  * src/include/crypto/kmgr.h
+  *
+  *-------------------------------------------------------------------------
+  */
+ #ifndef KMGR_H
+ #define KMGR_H
+ 
+ #include "common/cipher.h"
+ #include "common/kmgr_utils.h"
+ #include "storage/relfilenode.h"
+ #include "storage/bufpage.h"
+ 
+ /* GUC parameters */
+ extern bool key_management_enabled;
+ extern char *cluster_passphrase_command;
+ 
+ extern Size KmgrShmemSize(void);
+ extern void KmgrShmemInit(void);
+ extern void BootStrapKmgr(void);
+ extern void InitializeKmgr(void);
+ extern const CryptoKey *KmgrGetKey(int id);
+ 
+ #endif							/* KMGR_H */
diff --git a/src/include/pg_config.h.in b/src/include/pg_config.h.in
new file mode 100644
index fb270df..d50a7c9
*** a/src/include/pg_config.h.in
--- b/src/include/pg_config.h.in
***************
*** 385,390 ****
--- 385,393 ----
  /* Define to 1 if you have the `OPENSSL_init_ssl' function. */
  #undef HAVE_OPENSSL_INIT_SSL
  
+ /* Define to 1 if you have the `OPENSSL_init_crypto' function. */
+ #undef HAVE_OPENSSL_INIT_CRYPTO
+ 
  /* Define to 1 if you have the <ossp/uuid.h> header file. */
  #undef HAVE_OSSP_UUID_H
  
diff --git a/src/include/pgstat.h b/src/include/pgstat.h
new file mode 100644
index a821ff4..6549260
*** a/src/include/pgstat.h
--- b/src/include/pgstat.h
*************** typedef enum
*** 998,1003 ****
--- 998,1006 ----
  	WAIT_EVENT_DATA_FILE_TRUNCATE,
  	WAIT_EVENT_DATA_FILE_WRITE,
  	WAIT_EVENT_DSM_FILL_ZERO_WRITE,
+ 	WAIT_EVENT_KEY_FILE_READ,
+ 	WAIT_EVENT_KEY_FILE_WRITE,
+ 	WAIT_EVENT_KEY_FILE_SYNC,
  	WAIT_EVENT_LOCK_FILE_ADDTODATADIR_READ,
  	WAIT_EVENT_LOCK_FILE_ADDTODATADIR_SYNC,
  	WAIT_EVENT_LOCK_FILE_ADDTODATADIR_WRITE,
diff --git a/src/include/postmaster/postmaster.h b/src/include/postmaster/postmaster.h
new file mode 100644
index babc87d..b1f0721
*** a/src/include/postmaster/postmaster.h
--- b/src/include/postmaster/postmaster.h
*************** extern bool enable_bonjour;
*** 30,35 ****
--- 30,37 ----
  extern char *bonjour_name;
  extern bool restart_after_crash;
  
+ extern int	terminal_fd;
+ 
  #ifdef WIN32
  extern HANDLE PostmasterHandle;
  #else
diff --git a/src/include/utils/guc_tables.h b/src/include/utils/guc_tables.h
new file mode 100644
index 04431d0..a0e582a
*** a/src/include/utils/guc_tables.h
--- b/src/include/utils/guc_tables.h
*************** enum config_group
*** 89,94 ****
--- 89,95 ----
  	STATS,
  	STATS_MONITORING,
  	STATS_COLLECTOR,
+ 	ENCRYPTION,
  	AUTOVACUUM,
  	CLIENT_CONN,
  	CLIENT_CONN_STATEMENT,
diff --git a/src/test/Makefile b/src/test/Makefile
new file mode 100644
index 9774f53..6c998fc
*** a/src/test/Makefile
--- b/src/test/Makefile
*************** endif
*** 29,35 ****
  endif
  ifeq ($(with_openssl),yes)
  ifneq (,$(filter ssl,$(PG_TEST_EXTRA)))
! SUBDIRS += ssl
  endif
  endif
  
--- 29,35 ----
  endif
  ifeq ($(with_openssl),yes)
  ifneq (,$(filter ssl,$(PG_TEST_EXTRA)))
! SUBDIRS += ssl crypto
  endif
  endif
  
